/**  
* <p>Title: QyzxBusinessController.java</p>  
* <p>Description: </p>  
* @author dsc  
* @date 2020年4月22日  
* @version 1.0  
*/
package cn.timer.api.controller.qyzx;

import java.util.List;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import cn.timer.api.bean.qyzx.businessService.QyzxBuyRecord;
import cn.timer.api.bean.qyzx.businessService.QyzxOrderRecord;
import cn.timer.api.bean.qyzx.businessService.QyzxPayContent;
import cn.timer.api.bean.qyzx.businessService.QyzxRemainingQuantity;
import cn.timer.api.config.annotation.CurrentUser;
import cn.timer.api.config.annotation.UserBean;
import cn.timer.api.utils.Result;
import cn.timer.api.utils.ResultUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * <p>
 * Title: QyzxBusinessController.java
 * </p>
 * <p>
 * Description:
 * </p>
 * 
 * @author dsc
 * @date 2020年4月22日
 * @version 1.0
 */

@RestController
@Api(tags = "4.1企业中心(购买服务)")
@RequestMapping(value = "/qyzxbs", produces = { "application/json" })
public class QyzxBusinessController {

	@GetMapping(value = "/getAllQuantity")
	@ApiOperation(value = "获取套餐余量信息", httpMethod = "GET", notes = "接口发布说明")
	public Result<List<QyzxRemainingQuantity>> s(@CurrentUser UserBean userBean) {
		List<QyzxRemainingQuantity> list = QyzxRemainingQuantity.builder().build()
				.selectList(new LambdaQueryWrapper<QyzxRemainingQuantity>().eq(QyzxRemainingQuantity::getIsDelete, 0)
						.eq(QyzxRemainingQuantity::getOrgCode, userBean.getOrgCode()));
		return ResultUtil.data(list, "查询成功");
	}

	@GetMapping(value = "/getQuantity")
	@ApiOperation(value = "获取套餐余量信息(名称，数量，单位)", httpMethod = "GET", notes = "接口发布说明")
	public Result<List<QyzxRemainingQuantity>> getQuantity(@CurrentUser UserBean userBean) {
		List<QyzxRemainingQuantity> qyzxRemainingQuantitys = QyzxRemainingQuantity.builder().build()
				.selectList(new LambdaQueryWrapper<QyzxRemainingQuantity>().eq(QyzxRemainingQuantity::getIsDelete, 0)
						.eq(QyzxRemainingQuantity::getOrgCode, userBean.getOrgCode())
						.select(QyzxRemainingQuantity::getContent, QyzxRemainingQuantity::getCount,
								QyzxRemainingQuantity::getUnit));
		return ResultUtil.data(qyzxRemainingQuantitys, "获取成功");
	}

	@GetMapping(value = "/getPayList/Contract")
	@ApiOperation(value = "获取短信商品列表", httpMethod = "GET", notes = "接口发布说明")
	public Result<Object> getPayListwithContract(@CurrentUser UserBean userBean) {
		List<QyzxPayContent> list = QyzxPayContent.builder().build()
				.selectList(new LambdaQueryWrapper<QyzxPayContent>().eq(QyzxPayContent::getMid, 1).select(
						QyzxPayContent::getNowPrice, QyzxPayContent::getOriginalPrice, QyzxPayContent::getSpecification,
						QyzxPayContent::getExpiration));
		return ResultUtil.data(list, "获取成功");
	}

	@GetMapping(value = "/getPayList/Msg")
	@ApiOperation(value = "获取电子合同商品列表", httpMethod = "GET", notes = "接口发布说明")
	public Result<Object> getPayListWithMsg(@CurrentUser UserBean userBean) {
		List<QyzxPayContent> list = QyzxPayContent.builder().build()
				.selectList(new LambdaQueryWrapper<QyzxPayContent>().eq(QyzxPayContent::getMid, 2).select(
						QyzxPayContent::getNowPrice, QyzxPayContent::getOriginalPrice, QyzxPayContent::getSpecification,
						QyzxPayContent::getExpiration));
		return ResultUtil.data(list, "获取成功");
	}

	@PostMapping(value = "/generateOrder")
	@ApiOperation(value = "生成购买订单", httpMethod = "POST", notes = "接口发布说明")
	public Result<Object> generateOrder(@CurrentUser UserBean userBean, @RequestBody QyzxOrderRecord qyzxOrderRecord) {
		Integer orgCode = userBean.getOrgCode();
		String orderNo = String.valueOf(System.currentTimeMillis()) + orgCode; // 时间毫秒数+orgCode

		qyzxOrderRecord.setCreateUser(userBean.getEmpNum()); // 创建人
		qyzxOrderRecord.setOrgCode(orgCode);
		qyzxOrderRecord.setOrderNo(orderNo); // 订单号
		qyzxOrderRecord.setOrderStatus(1); // 订单状态-待支付

		Integer pcid = qyzxOrderRecord.getPcid(); // 商品id
		QyzxPayContent qyzxPayContent = QyzxPayContent.builder().build();
		QyzxPayContent qyzxPayContent2 = qyzxPayContent.selectOne(Wrappers.lambdaQuery(qyzxPayContent)
				.eq(QyzxPayContent::getId, pcid).select(QyzxPayContent::getContent, QyzxPayContent::getSpecification,
						QyzxPayContent::getExpiration, QyzxPayContent::getOriginalPrice, QyzxPayContent::getNowPrice));
		JSONObject json = JSONUtil.parseObj(qyzxPayContent2);
		qyzxOrderRecord.setOrderDetail(json.toString()); // 订单商品详情-json字符串
		qyzxOrderRecord.insert();

		// 请求第三方接口生成预支付交易，返回二维码链接code_url TODO
		
		// 生成二维码 TODO

		
		return ResultUtil.data(qyzxOrderRecord, "生成订单成功");

	}
	
	
	


	@PostMapping(value = "/buyMsg")
	@ApiOperation(value = "购买短信", httpMethod = "POST", notes = "接口发布说明")
	public Result<Object> buyMsg(@CurrentUser UserBean userBean, @RequestBody QyzxBuyRecord qyzxBuyRecord) {
		return ResultUtil.data("购买成功");
	}
	@PostMapping(value = "/buyContract")
	@ApiOperation(value = "购买电子合同", httpMethod = "POST", notes = "接口发布说明")
	public Result<Object> buyContract(@CurrentUser UserBean userBean, @RequestBody QyzxBuyRecord qyzxBuyRecord) {
		return ResultUtil.data("购买成功");
	}

}
